import unittest

import numpy as np

import altius_l1pp_inflight.scene.generation.lunar.rolo_wrapper as rolo


# import spiceypy as spice


# Testing lunar angle calculations from https://pds.nasa.gov/ds-view/pds/viewProfile.jsp?dsid=LP-L-6-TRAJECTORY-V1.0
def test_lunar_prospector():
    pass
    # os.chdir(os.path.dirname(os.path.abspath(__file__)))
    # spice.furnsh("data/latest_leapseconds.tls")
    # spice.furnsh("data/moon_pa_de421_1900-2050.bpc")
    # spice.furnsh("data/moon_080317.tf")
    # spice.furnsh("data/moon_assoc_me.tf")
    # spice.furnsh("data/pck00010.tpc")
    # spice.furnsh("data/earth_latest_high_prec.bpc")
    # spice.furnsh("data/naif0012.tls")
    # spice.furnsh("data/de421.bsp")
    # spice.furnsh("data/earth_assoc_itrf93.tf")
    #
    # lunar_data = np.genfromtxt("data/POS98_01.TAB", skip_header=1, delimiter=None, dtype=str)
    #
    # utc_times = lunar_data[:, 0]
    #
    # # selenocentric solar ecliptic coordinates:_
    # gse_x = [float(a) * 6372 for a in lunar_data[:, 13]]
    # gse_y = [float(a) * 6372 for a in lunar_data[:, 14]]
    # gse_z = [float(a) * 6372 for a in lunar_data[:, 15]]
    # latitudes = [float(a) for a in lunar_data[:, 4]]  # deg
    # longitudes = [float(a) for a in lunar_data[:, 5]]
    #
    # angle_calc = rolo.SpiceAngleCalc()
    #
    # for utc, gx, gy, gz, elat, elon in zip(utc_times, gse_x, gse_y, gse_z, latitudes, longitudes):
    #     # t = spice.utc2et(utc)
    #     # sv, a = spice.spkgeo(10, t, "J2000", 399)  # x-axis of GSE
    #     e2s = sv[0:3]
    #     x_axis = e2s / np.linalg.norm(e2s)
    #     v = sv[3:6]
    #     v = v / np.linalg.norm(v)
    #     z_axis = np.cross(x_axis, v)  # should hopefully define NORTH for the ecliptic
    #     y_axis = np.cross(z_axis, x_axis)
    #
    #     earth2spacecraft = gx * x_axis + gy * y_axis + gz * z_axis  # in J2000
    #
    #     g, sol_lon, sel_lat, sel_lon, moon_sun_au, s2m_km, s2e_km, e2m_km = angle_calc.compute_lunar_angles(
    #         np.array([t - 32.184]), np.array([earth2spacecraft]))
    #
    #     lon = sel_lon * 180 / np.pi
    #     lat = sel_lat * 180 / np.pi
    #
    #     if elon > 180:
    #         elon = elon - 360
    #
    #     print("Expected: ", elat)
    #     print("Actual:   ", lat)
    #     print("Expected: ", elon)
    #     print("Actual:   ", lon)
    #     print("")


# TODO these angles don't seem right
def test_lunar_angles():
    """
    Verify lunar angles computed using JPL SPICE:
    Pick specific angles from LuoJia1-01 paper (Jiang et. al., 2019)

    Case 1:
    2018-6-27T 23:43:23
    S/C: [-1372.54, -1335.73, 6747.3] km,
    sel_lon: 36.48, sel_lat: 73.51
    solar_sel_lon: 4.47
    moon-sun distance 1.02 AU
    phase: 2.83 deg

    Case 2:
    2018-11-23T 22:45:5
    S/C: [2067.28, 583.59, 6665.14] km
    sel_lon: 161.73, sel_lat: 55.78
    solar_sel_lon: -12.90
    moon-sun distance: 0.99 AU
    phase: 10.57 deg

    Case 3:
    2019-3-22T 17:40:18
    S/C: [-5952.3, 2538.92, 2697.62] km
    sel_lon: 130.48, sel_lat: 13.00
    solar_sel_lon: -17.91
    moon-sun distance: 1.00 AU
    phase: 24.3 deg

    Case 4:
    2019-5-21T 15:03:00
    S/C: [-2341.16, -3014.05, -5898.73] km
    sel_lon: 155.94, sel_lat: -35.78
    solar_sel_lon: -28.52
    moon-sun distance: 1.01
    phase: 33.86 deg
    """
    pass
    # os.chdir(os.path.dirname(os.path.abspath(__file__)))
    # spice.furnsh("data/latest_leapseconds.tls")
    # spice.furnsh("data/moon_pa_de421_1900-2050.bpc")
    # spice.furnsh("data/moon_080317.tf")
    # spice.furnsh("data/moon_assoc_me.tf")
    # spice.furnsh("data/pck00010.tpc")
    # spice.furnsh("data/earth_latest_high_prec.bpc")
    # spice.furnsh("data/naif0012.tls")
    # spice.furnsh("data/de421.bsp")
    # spice.furnsh("data/earth_assoc_itrf93.tf")
    #
    # spacecraft_pos = np.array([[-1372.54, -1335.73, 6747.3], [2067.28, 583.59, 6665.14],
    #                            [-5952.3, 2538.92, 2697.62], [-2341.16, -3014.05, -5898.73]])
    # expected_obs_sel_lon = np.array([36.48, 161.73, 130.48, 155.94])
    # expected_obs_sel_lat = np.array([73.51, 55.78, 13.00, -35.78])
    # expected_sol_sel_lon = np.array([4.47, -12.9, -17.91, -28.52])
    # expected_moon_sun_au = np.array([1.02, 0.99, 1.00, 1.01])
    # expected_phase = np.array([2.83, 10.57, 24.3, 33.86])
    # utc = np.array(["2018-6-27T 23:43:23", "2018-11-23T 22:45:5",
    #                 "2019-3-22T 17:40:18", "2019-5-21T 15:03:00"])
    # et = spice.str2et(utc)
    # tai_times = et - 32.184
    #
    # angle_calc = rolo.SpiceAngleCalc()
    # g, solar_lon, sel_lat, sel_lon, moon_sun_distance, sun_to_moon_km, sun_to_earth_km, earth_to_moon_km = \
    #     angle_calc.compute_lunar_angles(tai_times, spacecraft_pos)
    #
    # for i in range(0, 4):
    #     print("-----------------")
    #     print("    Case ", i + 1)
    #     print("-----------------")
    #     print("J2000 coordinates:")
    #     print(spacecraft_pos[i])
    #     print("")
    #     print("Sun-to-moon:")
    #     print(sun_to_moon_km[i])
    #     print("")
    #     print("Sun-to-earth:")
    #     print(sun_to_earth_km[i])
    #     print("")
    #     print("Earth-to-moon:")
    #     print(earth_to_moon_km[i])
    #     print("")
    #     print("phase angle: ", ang(g[i]))
    #     print("expected:    ", expected_phase[i])
    #     print("")
    #     print("solar longitude: ", ang(solar_lon[i]))
    #     print("expected:        ", expected_sol_sel_lon[i])
    #     print("")
    #     print("S/C latitude: ", ang(sel_lat[i]))
    #     print("expected:     ", expected_obs_sel_lat[i])
    #     print("")
    #     print("S/C longitude: ", ang(sel_lon[i]))
    #     print("expected:      ", expected_obs_sel_lon[i])
    #     print("")
    #     print("Moon-sun distance: ", moon_sun_distance[i])
    #     print("expected:          ", expected_moon_sun_au[i])


def ang(angle_rad):
    d = angle_rad * 180 / np.pi
    if d > 180:
        d = d - 360
    return d


def verify_rotation_matrix():
    a = np.array([[3.0, 4.0, 1.2], [-2.5, 3.1, -8.9], [1, 0, 0], [0, 0, 1]])
    a = a / np.linalg.norm(a, axis=1).reshape((4, 1))
    b = np.array([[-9.4, 1.8, 1.0], [0.1, 3.2, 1.4], [0, 1, 0], [1, 0, 0]])
    b = b / np.linalg.norm(b, axis=1).reshape((4, 1))
    rr = rolo.SpiceAngleCalc.compute_rotation_matrix(a, b)

    diff = np.array([np.linalg.norm(vb - np.dot(m, va.T)) for m, va, vb in zip(rr, a, b)])
    return diff


def verify_angles_at_flagstaff():
    pass
    # os.chdir(os.path.dirname(os.path.abspath(__file__)))
    #
    # spice.furnsh("data/latest_leapseconds.tls")
    # spice.furnsh("data/moon_pa_de421_1900-2050.bpc")
    # spice.furnsh("data/moon_080317.tf")
    # spice.furnsh("data/moon_assoc_me.tf")
    # spice.furnsh("data/pck00010.tpc")
    # spice.furnsh("data/earth_720101_031229.bpc")
    # spice.furnsh("data/naif0012.tls")
    # spice.furnsh("data/de421.bsp")
    # spice.furnsh("data/earth_assoc_itrf93.tf")
    #
    # et = spice.str2et("1998-12-30T03:45:06")
    # moon2sun_km, a = spice.spkpos("MOON", et, "ITRF93", "NONE", "SUN")
    # earth2sun_km, a = spice.spkpos("EARTH", et, "ITRF93", "NONE", "SUN")
    # earth2moon_km, a = spice.spkpos("EARTH", et, "ITRF93", "NONE", "MOON")
    #
    # d, radii = spice.bodvrd("EARTH", "RADII", 3)
    # r_e = radii[0]
    # r_p = radii[2]
    # f = (r_e - r_p) / r_e
    # flagstaff_lon_deg = -111.6513
    # flagstaff_lat_deg = 35.1983
    # ecef_flagstaff = spice.pgrrec("EARTH", flagstaff_lon_deg * np.pi / 180, flagstaff_lat_deg * np.pi / 180, 0, r_e, f)
    #
    # rr = spice.pxform("ITRF93", "J2000", et)
    # flagstaff = np.dot(rr, ecef_flagstaff)
    # tai_times = np.array([et - 32.184])
    #
    # angle_calc = rolo.SpiceAngleCalc()
    # g, solar_lon, sel_lat, sel_lon, moon_sun_distance, sun_to_moon_km, sun_to_earth_km, earth_to_moon_km = \
    #     angle_calc.compute_lunar_angles(tai_times, flagstaff, satellite_ref_frame="J2000")
    #
    # # compute sub-earth point on moon:
    # rect, a, b = spice.subpnt("NEAR POINT/ELLIPSOID", "MOON", et, "MOON_ME", "NONE", "EARTH")
    # r, sel_lonc, sel_latc = spice.reclat(rect)
    #
    # rect, a, b = spice.subpnt("NEAR POINT/ELLIPSOID", "EARTH", et, "ITRF93", "NONE", "MOON")
    # submoon_lon, submoon_lat, alt = spice.recpgr("EARTH", rect, r_e, f)
    #
    # print("phase angle: ", g * 180 / np.pi)
    # print("expected:    40.6")
    # print("")
    # print("solar longitude: ", solar_lon * 180 / np.pi)
    # print("")
    # print("selenographic latitude: ", sel_lat * 180 / np.pi)
    # print("earth center sel lat: ", sel_latc * 180 / np.pi)
    # print("expected:            1.120")
    # print("sub-moon earth lat: ", submoon_lat * 180 / np.pi)
    # print("")
    # print("selenographic longitude: ", sel_lon * 180 / np.pi)
    # print("earth center sel lon: ", sel_lonc * 180 / np.pi)
    # print("expected:             -0.145")
    # print("sub-moon earth lon: ", submoon_lon * 180 / np.pi)


class TestRoloAstropyEphemeris(unittest.TestCase):

    def test_lunar_prospector(self):
        test_lunar_prospector()

    def test_lunar_angles(self):
        test_lunar_angles()

    def test_rotation_matrix(self):
        self.assertTrue(np.all(verify_rotation_matrix() < 1e-15))

    def test_angles_at_flagstaff_az(self):
        verify_angles_at_flagstaff()
